/* digital oszilloskop mit avr
 by: Clemens Helfmeier
 25.8.06
 */

#include "board.h"
#include "oszi.h"
#include "commandline.h"

#include "oszi_asm.h"

#include <stdlib.h>
#include <string.h>
u16 divider;
u8 average;
u8 timeout;


#define OSZI_START	(1<<0)
u8 oszi_status = 0;

u8 sample_data[ DATA_LEN ];

void oszi_init( void ) {

}

void oszi_main( void ) {

	if ((oszi_status & OSZI_START) != 0) {
		// do one sampling
		memset( sample_data, 0x00, DATA_LEN );
		if (divider == 1) {
			sample_1( average );
		} else if (divider == 2) {
			sample_2();
		} else if (divider == 3) {
			sample_3();
		} else if (divider == 4) {
			sample_4();
		} else if (divider == 5) {
			sample_5();
		} else if (divider == 6) {
			sample_6();
		} else if (divider == 7) {
			sample_7();
		} else if (divider == 8) {
			sample_8();
		} else if (divider < 256) {
			sample_255( divider & 0xFF );
		} else {
			sample_x( divider );
		}

		// nun zurcksenden
		for (u16 i = 0; i< DATA_LEN; i++) {
			cmd_sends( itoa( (sample_data[i]&0xFF), s, 10 ) );
			cmd_sendcs( " " );
		}
		
		oszi_status &= ~OSZI_START;
	}
}

void oszi_dbg( char * str ) {
	if (str == 0) {
	} else {
		str = cmd_skip_spaces(str);
		if (cmd_cmp( str, "set", 3 ) == 0) {
			str = cmd_skip_spaces(str+3);
			if (cmd_cmp( str, "div", 3 ) == 0) {
				// divider of cpu-frequenc
				divider = atoi( str+3 );
			} else if (cmd_cmp( str, "timeout", 7 ) == 0) {
				// timeout in seconds
				timeout = atoi( str+7 );
			} else if (cmd_cmp( str, "trigger", 7 ) == 0) {
				str = cmd_skip_spaces(str+7);
				// setting of trigger parameters, not yet implemented
			}
		} else if (cmd_cmp( str, "start", 5 ) == 0)  {
			// start a sample after triggering
			oszi_status |= OSZI_START;
			average = atoi( str + 5 );
			if (average == 0) average = 1;
			dbg_oszics( "averaging: " ); dbg_oszis( itoa( average, s, 10 ) ); dbg_oszics( ".\n" );
		}
	}
}