

; digital oszilloskop mit avr
; by: Clemens Helfmeier
; 25.8.06

#define __SFR_OFFSET	0
#include <avr/io.h>

#define TRIGGER_PIN		PIND
#define TRIGGER_BIT		5

.macro TRIGGER
	sbic TRIGGER_PIN, TRIGGER_BIT
	rjmp . - 4
	sbis TRIGGER_PIN, TRIGGER_BIT
	rjmp . - 4
.endm

.global sample_data

.func sample_1
.global sample_1
; Parameter: number of runs to use for averaging...
sample_1:
	push r29
	in r29, SREG
	push r29
	push r30
	push r31

	clr r30
	clr r31
	ldi r29, 29
x1:
	ld r0, z+
	push r0
	dec r29
	brne x1

	cli
	
	clr r29
sample_1_a:

	ldi r30, lo8(sample_data)
	ldi r31, hi8(sample_data)


	; wait until trigger impuls comes
	TRIGGER
	; jetzt wurde getriggert, ungewissheit im zeitpunkt: 0..2 samples
	; do one sample
	#include "sample1.S"

	tst r29
	brne sample_1_add1
		#include "sample1_save.S"
		rjmp sample_1_save1
sample_1_add1:
		#include "sample1_add.S"
		rjmp sample_1_save1
sample_1_save1:

	ldi r17, 1

sample_1_b:
	; wait until new trigger impuls comes
	TRIGGER
	; jetzt wurde getriggert, ungewissheit im zeitpunkt: 0..2 samples
	; warte 16*r17 takte
	mov r16, r17		;1
	lsl r16				;1
	lsl r16				;1
	dec r16				;1 ^= 4
sample_1_d:
	nop					;1
	dec r16				;1
	brne sample_1_d		;2/1 1 = 4. nun noch
	nop					;1 = 16*r17
	; do one 16-sample shot, this takes 16 sample cycles and 32 store cycles
	#include "sample1.S"

	tst r29
	brne sample_1_add2
		#include "sample1_save.S"
		rjmp sample_1_save2
sample_1_add2:
		#include "sample1_add.S"
		rjmp sample_1_save2
sample_1_save2:

	inc r17				; repeat as long as 1024 samples together
	cpi r17, (1024/16)
	brsh sample_1_e
	rjmp sample_1_b
sample_1_e:

	inc r29
	cp r29, r24
	brsh sample_1_f
	rjmp sample_1_a
sample_1_f:
	
	ldi r30, 29
	ldi r31, 0
	ldi r29, 29
x2:
	pop r0
	st -z, r0
	dec r29
	brne x2

	pop r31
	pop r30
	pop r29
	out SREG, r29
	pop r29
	ret
.size sample_1, . - sample_1
.endfunc


.func sample_2
.global sample_2
sample_2:
	ret
.size sample_2, . - sample_2
.endfunc


.func sample_3
.global sample_3
sample_3:
	in r16, SREG
	push r16
	cli
	
	ldi r30, lo8(sample_data)
	ldi r31, hi8(sample_data)

	TRIGGER
	#include "sample3.S"

	pop r16
	out SREG, r16
	ret
.size sample_3, . - sample_3
.endfunc


.func sample_4
.global sample_4
sample_4:
	ret
.size sample_4, . - sample_4
.endfunc


.func sample_5
.global sample_5
sample_5:
	ret
.size sample_5, . - sample_5
.endfunc


.func sample_6
.global sample_6
sample_6:
	ret
.size sample_6, . - sample_6
.endfunc


.func sample_7
.global sample_7
sample_7:
	ret
.size sample_7, . - sample_7
.endfunc


.func sample_8
.global sample_8
sample_8:
	ret
.size sample_8, . - sample_8
.endfunc


.func sample_255
.global sample_255
sample_255:
	ret
.size sample_255, . - sample_255
.endfunc


.func sample_x
.global sample_x
sample_x:
	ret
.size sample_x, . - sample_x
.endfunc
