

/** @file uart.h
 * Header file for UART routines
 * @author Clemens Helfmeier
 * @date 09.07.2006
 */

#ifndef _UART_H_
#define _UART_H_

#include "board.h"

#define UART0_BAUDRATE		19200
#define UART1_BAUDRATE          4800

#define UBRR0		64
// ((F_CPU / (16*UART0_BAUDRATE))-1)
#define UBRR1		192
// ((F_CPU / (16*UART1_BAUDRATE))-1)

#define UART0_RXHANDLER		uart0_rx_handler( UDR0 );
void uart0_rx_handler( char c );
#define UART1_RXHANDLER	        uart1_rx_handler( UDR1 );
void uart1_rx_handler( char c );

void uart_init( void );

void uart0_putc( char s );
void uart1_putc( char s );
#ifndef UART0_RXHANDLER
void uart0_gets( char * s, u8 maxlen );
char uart0_getc( void );
#endif
#ifndef UART1_RXHANDLER
void uart1_gets( char * s, u8 maxlen );
char uart1_getc( void );
#endif

void uart0_puts_p( char * s );
void uart1_puts_p( char * s );
void uart0_puts( char * s );
void uart1_puts( char * s );


#endif